From: Ole Streicher <debian@liska.ath.cx>
Date: Sat, 5 Aug 2017 11:30:42 +0200
Subject: Remove Tclx dependency

The package seems to have only little dependencies of tclx. Since Tclx
is not available for tcl8.6 and up, the dependency is removed. To get
the "fork" call, we additionally need the "expect" package.
---
 astrotcl/library/AstrotclInit.tcl  |  2 +-
 cat/library/AstroCat.tcl           |  2 +-
 cat/library/AstroImage.tcl         |  2 +-
 cat/library/CatInit.tcl            |  2 +-
 rtd/library/Rtd.tcl                |  2 +-
 rtd/library/RtdImageBias.tcl       |  6 ++++++
 rtd/library/RtdImageFitsHeader.tcl | 10 ++++++----
 rtd/library/RtdImageHduChooser.tcl |  3 ++-
 rtd/library/RtdImagePerf.tcl       |  1 +
 rtd/library/RtdImagePick2.tcl      |  3 ++-
 rtd/library/RtdInit.tcl            |  2 +-
 rtd/library/tRtd.tcl               |  1 +
 rtd/util/rmipc.tcl                 |  2 +-
 skycat/library/SkycatInit.tcl      |  4 +++-
 tclutil/library/Batch.tcl          |  5 +++--
 tclutil/library/TclutilInit.tcl    |  3 +--
 tclutil/library/canvastext.tcl     |  4 ++--
 tclutil/library/itcldoc.tcl        |  1 -
 tclutil/library/list.tcl           |  6 ++++++
 19 files changed, 40 insertions(+), 21 deletions(-)

diff --git a/astrotcl/library/AstrotclInit.tcl b/astrotcl/library/AstrotclInit.tcl
index bced84d..106a597 100644
--- a/astrotcl/library/AstrotclInit.tcl
+++ b/astrotcl/library/AstrotclInit.tcl
@@ -15,7 +15,7 @@
 package require Tclutil
 package require Tclx
 
-if {![lcontain $auto_path $astrotcl_library]} {
+if { $auto_path ni $astrotcl_library } {
     lappend auto_path $astrotcl_library
 }
 
diff --git a/cat/library/AstroCat.tcl b/cat/library/AstroCat.tcl
index b872fe0..be55726 100644
--- a/cat/library/AstroCat.tcl
+++ b/cat/library/AstroCat.tcl
@@ -155,7 +155,7 @@ itcl::class cat::AstroCat {
 	    return
 	}
 	if {"$onoff" == "on"} {
-	    lassign [pipe] rfd_ wfd_
+	    lassign [chan pipe] rfd_ wfd_
 	    fileevent $rfd_ readable [code $this feedback]
 	    $w_.cat feedback $wfd_
 	} elseif {[info exists rfd_]} {
diff --git a/cat/library/AstroImage.tcl b/cat/library/AstroImage.tcl
index b1177fc..636c626 100644
--- a/cat/library/AstroImage.tcl
+++ b/cat/library/AstroImage.tcl
@@ -401,7 +401,7 @@ itcl::class cat::AstroImage {
 	    return
 	}
 	if {"$onoff" == "on"} {
-	    lassign [pipe] rfd_ wfd_
+	    lassign [chan pipe] rfd_ wfd_
 	    fileevent $rfd_ readable [code $this feedback]
 	    $w_.im feedback $wfd_
 	} elseif {[info exists rfd_]} {
diff --git a/cat/library/CatInit.tcl b/cat/library/CatInit.tcl
index e0dca90..38f9da6 100644
--- a/cat/library/CatInit.tcl
+++ b/cat/library/CatInit.tcl
@@ -14,7 +14,7 @@ package require img::xpm
 package require Tclutil
 package require Astrotcl
 
-if {![lcontain $auto_path $cat_library]} {
+if { $auto_path ni $cat_library } {
     lappend auto_path $cat_library
 }
 
diff --git a/rtd/library/Rtd.tcl b/rtd/library/Rtd.tcl
index 27a28ca..211fe04 100644
--- a/rtd/library/Rtd.tcl
+++ b/rtd/library/Rtd.tcl
@@ -650,7 +650,7 @@ itcl::class rtd::Rtd {
 	set t6 "Tcl version:\t[info patchlevel]"
 	set t7 "Tcl package path:\t$tcl_pkgPath"
 	set t8 "Package versions:\t"
-	foreach el "Tclx Itcl Itk Tkx BLT" {
+	foreach el "Itcl Itk BLT" {
 	    set t8 "$t8$el[package versions $el] "
 	}
         DialogWidget $w_.rtd_about \
diff --git a/rtd/library/RtdImageBias.tcl b/rtd/library/RtdImageBias.tcl
index 856ad74..a305e2f 100644
--- a/rtd/library/RtdImageBias.tcl
+++ b/rtd/library/RtdImageBias.tcl
@@ -10,6 +10,12 @@
 
 itk::usual RtdImageBias {}
 
+# see http://wiki.tcl.tk/2028
+proc lvarpush {var val {ndx end}} {
+  upvar $var args
+  set args [linsert $args $ndx $val]
+}
+
 # RtdImageBias is a class for controlling the subtraction of
 # a bias frame.
 
diff --git a/rtd/library/RtdImageFitsHeader.tcl b/rtd/library/RtdImageFitsHeader.tcl
index 2452d2f..2e439b0 100644
--- a/rtd/library/RtdImageFitsHeader.tcl
+++ b/rtd/library/RtdImageFitsHeader.tcl
@@ -14,6 +14,8 @@
 # pdraper     20/02/07   Formatting changes: keep empty lines (one anyway) 
 #                        and print blank COMMENT/HISTORY lines with blanks, do
 #                        not fake that they start with COMMENT/HISTORY.
+# check for empty list. Replacement for TclX.
+package require Tclutil
 
 itk::usual RtdImageFitsHeader {}
 
@@ -160,7 +162,7 @@ itcl::class rtd::RtdImageFitsHeader {
 	set tconfig_(sort_cols) $sort_cols
 	set tconfig_(sort_order) $sort_order
 
-	loop i 0 $num_hdus_ {
+	for {set i 0} {$i < $num_hdus_} {incr i} {
             $tabnotebook_(table$i) config -sort_cols $sort_cols \
 		    -sort_order $sort_order
 	    $tabnotebook_(table$i) new_info
@@ -173,7 +175,7 @@ itcl::class rtd::RtdImageFitsHeader {
 	global $var
 	set val [set $var]
 	set tconfig_($label) $val
-	loop i 0 $num_hdus_ {
+	for {set i 0} {$i < $num_hdus_} {incr i} {
 	    $tabnotebook_(table$i) set_option $label Show $val
 	    $tabnotebook_(table$i) new_info
 	}
@@ -220,7 +222,7 @@ itcl::class rtd::RtdImageFitsHeader {
 
 	set length [string length [$listbox get 0]]
 
-        loop n $start_idx $end_idx {
+        for {set n $start_idx} {$n < $end_idx} {incr n} {
 	    set row [string tolower [$listbox get $n]]
             if {[catch {regexp -indices $string $row indices} idx] } { continue }
 	    if { $idx > 0 } {
@@ -278,7 +280,7 @@ itcl::class rtd::RtdImageFitsHeader {
 	set hlist [$image_ hdu list]
 
 	set ExtName "HDU 1"
-	loop i 0 $hdu_count {
+	for {set i 0} {$i < $hdu_count} {incr i} {
 	    set hdu [expr {$i + 1}]
 	    set list [lindex $hlist $i]
 	    
diff --git a/rtd/library/RtdImageHduChooser.tcl b/rtd/library/RtdImageHduChooser.tcl
index 9ffd96b..64b42a1 100644
--- a/rtd/library/RtdImageHduChooser.tcl
+++ b/rtd/library/RtdImageHduChooser.tcl
@@ -17,6 +17,7 @@
 # pbiereic        11/10/08   Break image display loop after failure.
 # pbiereic        26/11/08   Using 'view update' for HDU images display.
 #                            Using a toplevel window for the HDU images display.
+package require Tclutil
 
 itk::usual RtdImageHduChooser {}
 
@@ -443,7 +444,7 @@ itcl::class rtd::RtdImageHduChooser {
     
     private method svinfo {} {
 	set list [array get ext_ *NAXIS*]
-	loop i 0 [llength $list] 2 {
+	for {set i 0} {$i < [llength $list]} {incr i 2} {
 	    lappend newlist "[lindex $list $i] [lindex $list [expr {$i+1}]]"
 	}
 	set newlist [lsort -increasing -index 0 $newlist]
diff --git a/rtd/library/RtdImagePerf.tcl b/rtd/library/RtdImagePerf.tcl
index c26d97c..5d7f6ac 100644
--- a/rtd/library/RtdImagePerf.tcl
+++ b/rtd/library/RtdImagePerf.tcl
@@ -9,6 +9,7 @@
 # D. Hopkinson    31 Jan 97  Created
 # P.Biereichel    21/07/97   % display is the default + some bug fixes
 # P.Biereichel    01/03/01   Only % display suported + code revised
+package require Tclutil
 
 itk::usual RtdImagePerf {}
 
diff --git a/rtd/library/RtdImagePick2.tcl b/rtd/library/RtdImagePick2.tcl
index e4bfbbb..6c28d6e 100644
--- a/rtd/library/RtdImagePick2.tcl
+++ b/rtd/library/RtdImagePick2.tcl
@@ -62,6 +62,7 @@
 # NOTES
 # - In contrast to RtdImagePick, RtdImagePick2 does not use tkwait which may
 #   cause problem for an inheriting class due to nested calls to tkwait.
+package require Tclutil
 
 itk::usual RtdImagePick2 { }
 
@@ -127,7 +128,7 @@ itcl::class rtd::RtdImagePick2 {
 		{Set the magnification factor of the zoom} \
 		-menu [menu $magMenu_]
 
-	loop i 2 31 {
+	for {set i 2} {$i < 31} {incr i} {
 	    $m.mag add radiobutton -label " ${i}x" \
 		    -command [code $this scaleZoom $i] \
 		    -variable $magMenu_
diff --git a/rtd/library/RtdInit.tcl b/rtd/library/RtdInit.tcl
index e86fc22..0c1288a 100644
--- a/rtd/library/RtdInit.tcl
+++ b/rtd/library/RtdInit.tcl
@@ -14,7 +14,7 @@
 package require Tclutil
 package require Astrotcl
 
-if {![lcontain $auto_path $rtd_library]} {
+if { $auto_path ni $rtd_library} {
     lappend auto_path $rtd_library
 }
 
diff --git a/rtd/library/tRtd.tcl b/rtd/library/tRtd.tcl
index eca4c26..34e6507 100644
--- a/rtd/library/tRtd.tcl
+++ b/rtd/library/tRtd.tcl
@@ -10,6 +10,7 @@
 # who             when       what
 # --------------  ---------  ----------------------------------------
 # pbiereic        01/03/01   Created
+package require Tclutil
 
 itk::usual tRtd {}
 
diff --git a/rtd/util/rmipc.tcl b/rtd/util/rmipc.tcl
index b1282c6..6a64ade 100644
--- a/rtd/util/rmipc.tcl
+++ b/rtd/util/rmipc.tcl
@@ -20,7 +20,7 @@ foreach opt $opts {
     }
     set f [open "|ipcs $opt"]
     while {[gets $f line] != -1} {
-        if { ![lcontain $line $env(USER)]} { continue }
+        if { $line ni $env(USER) } { continue }
 	set num [lindex $line 1]
 	if {![catch {expr $num}]} {
 	    if {[catch {exec ipcrm $opt $num} msg]} {
diff --git a/skycat/library/SkycatInit.tcl b/skycat/library/SkycatInit.tcl
index 4ad1732..741efc6 100644
--- a/skycat/library/SkycatInit.tcl
+++ b/skycat/library/SkycatInit.tcl
@@ -15,9 +15,11 @@ package require Tclutil
 package require Astrotcl
 package require Cat
 
-if {![lcontain $auto_path $skycat_library]} {
+if { $auto_path ni $skycat_library } {
     lappend auto_path $skycat_library
 }
 
 namespace eval skycat {namespace export *}
 namespace import -force skycat::*
+namespace import ::tcl::mathfunc::max
+namespace import ::tcl::mathfunc::min
diff --git a/tclutil/library/Batch.tcl b/tclutil/library/Batch.tcl
index 5798aa7..f08777c 100644
--- a/tclutil/library/Batch.tcl
+++ b/tclutil/library/Batch.tcl
@@ -40,6 +40,7 @@
 #                        handlers. This was causing problems with
 #                        Starlink infrastructure s/w (HDS).
 #            02 Mar 99   Merged skycat 2.3.2 changes
+package require Expect
 
 itk::usual Batch {}
 
@@ -81,7 +82,7 @@ itcl::class util::Batch {
 	}
 	flush stdout
 	flush stderr
-	pipe rfd wfd
+	lassign [chan pipe] rfd wfd
 	set pid [fork]
 	if {$pid == 0} {
 	    # child
@@ -98,7 +99,7 @@ itcl::class util::Batch {
 	    puts $wfd $status
 	    flush $wfd
 	    close $wfd
-	    kill SIGKILL [pid]
+	    kill [pid] 9
 	} else {
 	    set bg_pid_ $pid
 	    fileevent $rfd readable [code $this read_pipe $rfd $wfd]
diff --git a/tclutil/library/TclutilInit.tcl b/tclutil/library/TclutilInit.tcl
index d984882..56ec479 100644
--- a/tclutil/library/TclutilInit.tcl
+++ b/tclutil/library/TclutilInit.tcl
@@ -16,9 +16,8 @@ set tcl_precision 17
 
 package require Itcl
 package require Itk
-package require Tclx
 
-if {![lcontain $auto_path $tclutil_library]} {
+if {$auto_path ni $tclutil_library} {
     lappend auto_path $tclutil_library
 }
 
diff --git a/tclutil/library/canvastext.tcl b/tclutil/library/canvastext.tcl
index f08ca43..4275564 100644
--- a/tclutil/library/canvastext.tcl
+++ b/tclutil/library/canvastext.tcl
@@ -21,7 +21,7 @@ proc ct_cursor_position_in_line {canvas item} {
 proc ct_search_forward_char {canvas item char} {
     if {![lempty $item]} {
 	set text [lindex [$canvas itemconfigure $item -text] 4]
-	loop i [$canvas index $item insert] [$canvas index $item end] {
+	for {set i [$canvas index $item insert]} {$i < [$canvas index $item end]} {incr i} {
 	    if {$char == [string index $text $i]} {
 		return $i
 	    }
@@ -37,7 +37,7 @@ proc ct_search_forward_char {canvas item char} {
 proc ct_search_backward_char {canvas item char} {
     if {![lempty $item]} {
 	set text  [lindex [$canvas itemconfigure $item -text] 4]
-	loop i [expr {[$canvas index $item insert] - 1}] 0 -1 {
+	for {set i [expr {[$canvas index $item insert] - 1}]} {$i > 0} {decr i} {
 	    if {$char == [string index $text $i]} {
 		return $i
 	    }
diff --git a/tclutil/library/itcldoc.tcl b/tclutil/library/itcldoc.tcl
index 02f7a33..388e763 100644
--- a/tclutil/library/itcldoc.tcl
+++ b/tclutil/library/itcldoc.tcl
@@ -36,7 +36,6 @@ exec tclsh $0 ${1+"$@"}
 # A.Brighton 07 Jan 98   created
 
 package require Itcl
-package require Tclx
 
 itcl::class ItclDoc {
 
diff --git a/tclutil/library/list.tcl b/tclutil/library/list.tcl
index 49c614c..a0d33a8 100644
--- a/tclutil/library/list.tcl
+++ b/tclutil/library/list.tcl
@@ -50,3 +50,9 @@ proc lreverse {list} {
     }
     return $l
 }
+
+proc lempty {list} {
+    if {[catch {llength $list} len]} { return 0 }
+    return [expr {$len == 0}]
+}
+
